#!/bin/sh
/usr/bin/sudo apt install dos2unix
/usr/bin/sudo rm -rf /etc/openvpn/cert_new
/usr/bin/sudo mkdir /etc/openvpn/cert_new
/usr/bin/sudo cp -r /etc/openvpn/easy-rsa /etc/openvpn/cert_new
cd /etc/openvpn/cert_new/easy-rsa && /usr/bin/sudo rm -rf /etc/openvpn/cert_new/easy-rsa/pki
/usr/bin/sudo find /etc/openvpn/cert_new/easy-rsa/ -name "vars" | xargs dos2unix
cd /etc/openvpn/cert_new/easy-rsa && /usr/bin/sudo ./easyrsa init-pki
cd /etc/openvpn/cert_new/easy-rsa && yes | /usr/bin/sudo ./easyrsa build-ca nopass
cd /etc/openvpn/cert_new/easy-rsa && yes | /usr/bin/sudo ./easyrsa gen-req server nopass
cd /etc/openvpn/cert_new/easy-rsa && echo 'yes' | /usr/bin/sudo ./easyrsa sign-req server server
cd /etc/openvpn/cert_new/easy-rsa && /usr/bin/sudo ./easyrsa gen-dh
cd /etc/openvpn/cert_new/easy-rsa && /usr/bin/sudo openvpn --genkey secret ta.key
cd /etc/openvpn/cert_new/easy-rsa && yes | /usr/bin/sudo ./easyrsa gen-req client1 nopass
cd /etc/openvpn/cert_new/easy-rsa && echo 'yes' | /usr/bin/sudo ./easyrsa sign-req client client1

cd /etc/openvpn/cert_new/easy-rsa && cp pki/ca.crt pki/private/ca.key  /etc/openvpn/cert_new/
cd /etc/openvpn/cert_new/easy-rsa && cp pki/issued/server.crt pki/private/server.key  /etc/openvpn/cert_new/
cd /etc/openvpn/cert_new/easy-rsa && cp pki/issued/client1.crt pki/private/client1.key  /etc/openvpn/cert_new/
cd /etc/openvpn/cert_new/easy-rsa && cp ta.key pki/dh.pem  /etc/openvpn/cert_new/

/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/ca.crt
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/ca.key
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/server.crt
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/server.key
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/client1.crt
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/client1.key
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/ta.key
/usr/bin/sudo chmod -R 755 /etc/openvpn/cert_new/dh.pem

##使用openssl命令验证证书有效性
#cd /etc/openvpn/cert_new/ &&  openssl verify -CAfile ca.crt -purpose sslserver server.crt

cd /etc/openvpn/cert_new/ && /usr/bin/sudo cp -rf ca.crt client1.crt client1.key dh.pem /etc/openvpn/keys/
cd /etc/openvpn/cert_new/ && /usr/bin/sudo cp -rf server.crt server.key ta.key /etc/openvpn/keys/

/usr/bin/sudo systemctl daemon-reload
/usr/bin/sudo update-rc.d -f openvpn remove 2>/dev/null
/usr/bin/sudo /etc/init.d/openvpn stop
/usr/bin/sudo update-rc.d iptables.sh defaults 02>/dev/null
/usr/bin/sudo update-rc.d openvpn defaults 03>/dev/null

/usr/bin/sudo /unas/sbin/create_vpnca.sh

/usr/bin/sudo /etc/init.d/openvpn restart


